#include<bits/stdc++.h>
using namespace std;
const int nmax=5e4+42,mmax=1e5+42;
int n,m;
vector<int> adj[nmax];
bool been[nmax];
vector< pair<int,int> > outp;
pair<int,int> blocked;
void dfs(int node)
{
if(been[node])return;
been[node]=1;
for(auto k:adj[node])
{
    if(node==blocked.first&&k==blocked.second)continue;
    if(node==blocked.second&&k==blocked.first)continue;
    outp.push_back({node,k});
    dfs(k);
}

}
bool b[nmax];

vector<int> gr[nmax];

void dfs_normal(int node)
{
if(b[node])return;
b[node]=1;
for(auto k:gr[node])
{
    dfs_normal(k);
}

}

map< pair<int,int>,bool > seen;
pair<int,int> edges[mmax];
void make_graph()
{
//cout<<"making"<<endl;
for(int i=1;i<=n;i++)gr[i].clear();
int SZ=outp.size();
for(int i=0;i<SZ;i++)
{
    int p=outp[i].first,q=outp[i].second;
    if(p>q)swap(p,q);
    if(seen[{p,q}]==0)
        {
        //cout<<outp[i].first<<" with "<<outp[i].second<<endl;
        gr[outp[i].first].push_back(outp[i].second);
        }
    seen[{p,q}]=1;
}
seen.clear();
outp.clear();
//cout<<"made"<<endl;
}
int SZ[nmax];
vector<int> trav[nmax];
bool solved[nmax];
void dfs_back(int node)
{
if(solved[node])return;
solved[node]=1;
for(auto k:trav[node])
    dfs_back(k);
}
bool work()
{
    memset(solved,0,sizeof(solved));
    for(int i=1;i<=n;i++)trav[i].clear();

    for(int i=1;i<=n;i++)
        for(auto k:gr[i])
        trav[k].push_back(i);
    blocked={0,0};
    for(int i=1;i<=n;i++)
    if(solved[i]==0)
    {
        memset(b,0,sizeof(b));
        dfs_normal(i);
        for(int j=1;j<=n;j++)
            if(b[j]==0)return 0;
        solved[i]=1;
        for(auto k:trav[i])
            dfs_back(k);
    }
    else
        for(auto k:trav[i])
            dfs_back(k);
//cout<<"work :)"<<endl;
return 1;
}

void print_graph(int s)
{
for(int i=1;i<=n;i++)
    assert(adj[i].size()>=2&&SZ[i]>=2);

if(work()==0)
{
cout<<0<<endl;
exit(0);
}

if(s==1)cout<<s<<endl;
for(int i=1;i<=n;i++)
    for(auto k:gr[i])
    {
    cout<<i<<" "<<k<<endl;
    }
exit(0);
}
int main()
{
cin>>n>>m;
int p,q;
for(int i=1;i<=m;i++)
{
cin>>p>>q;
adj[p].push_back(q);
adj[q].push_back(p);
SZ[p]++;
SZ[q]++;
}
for(int i=1;i<=n;i++)
    if(SZ[i]<2)
    {
    cout<<0<<endl;
    return 0;
    }

if(n<=500)
{

for(int i=1;i<=n;i++)
    for(auto k:adj[i])
    {
    blocked={i,k};
    memset(been,0,sizeof(been));
    dfs(1);
    make_graph();
        if(work()){cout<<2<<endl<<i<<" "<<k<<endl;print_graph(0);return 0;}
    }

}

blocked={0,0};
memset(been,0,sizeof(been));
dfs(1);
make_graph();
print_graph(1);
return 0;
}
/*
6 7
1 2
2 3
2 4
3 5
3 6
4 5
5 6

5 6
1 2
1 4
2 4
2 3
3 5
2 5

5 7
1 2
1 4
2 4
2 3
3 5
2 5
2 4


6 7
1 3
2 3
1 2
3 7
4 5
4 6
5 6
*/
