#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#define N 50001
using namespace std;
int n,m;

struct Edge
{
    int v,nas;
    Edge(int v,int nas):v(v),nas(nas){}
};

bool fff(Edge a,Edge b)
{
    return a.v<b.v;
}

struct Prog
{
    vector <Edge> g[N];
    vector <Edge>::iterator it;
    pair<int,int> out[2*N];
    bool f[N]={};
    int mechta=1,outbr=0,m1,m2;




    int fup[N],t[N],tim=0;

    void addedge(int u,int v)
    {
        out[outbr].first = u;
        out[outbr++].second = v;
        it=lower_bound(g[v].begin(),g[v].end(),Edge(u,0),fff);
        it->nas=1;
    }

    void dfs(int u)
    {
        f[u]=1;
        t[u]=++tim;
        fup[u]=10000000;
      //  cout<<u<< endl;
        for(Edge e:g[u])
        {
            if(f[e.v]==0)
            {
                addedge(u,e.v);
                dfs(e.v);
                if(t[u]<fup[e.v]) mechta=0;
                fup[u]=min(fup[u],fup[e.v]);
            }
            else if(e.nas==0) fup[u]=min(fup[u],t[e.v]);
        }
        int maxt=0,maxv;
        for(Edge e:g[u])
        {
            if(e.nas==0 && t[e.v]<t[u])
                {
                    if(mechta==1 && fup[u]<t[e.v])
                    {
                        mechta=2;
                        m1=u; m2=e.v;
                        it=lower_bound(g[e.v].begin(),g[e.v].end(),Edge(u,0),fff);
                        it->nas=1;
                    }
                    else addedge(u,e.v);
                }
        }
        fup[u]=min(t[u],fup[u]);
        //cout<<u<<" - "<<fup[u]<< endl;

    }

    void output()
    {
        cout<<mechta<< endl;
        if(mechta>0)
        {
            if(mechta==2)
                    cout<<m1<<" "<<m2<< endl;
            for(int i=0; i<outbr; i++)
                printf("%i %i\n",out[i].first,out[i].second);
        }
    }
} Pr1;

struct Par
{
    int l,r;
} ed[100000];

int main()
{
    int a,b,i,j;
    cin>>n>>m;
    if(n<=500)
    {
        for(i=1; i<=m; i++)
        {
            scanf("%i%i",&a,&b);
            ed[i].l=a; ed[i].r=b;
        }
        for(i=1; i<=m; i++)
        {
            Prog pr;
            for(j=1; j<=m; j++)
            {
                if(j!=i)
                {
                    a=ed[j].l; b=ed[j].r;
                    pr.g[a].push_back(Edge(b,0));
                    pr.g[b].push_back(Edge(a,0));
                }
                for(i=1; i<=n; i++)
                    sort(pr.g[i].begin(),pr.g[i].end(),fff);
                pr.dfs(n-1);
                if(pr.mechta==1)
                {
                    pr.m1=ed[i].l; pr.m2=ed[i].r;
                    pr.mechta=2;
                    pr.output();
                    return 0;
                }
            }
        }
    }
    else
    {
        for(i=1; i<=m; i++)
        {
            scanf("%i%i",&a,&b);
            Pr1.g[a].push_back(Edge(b,0));
            Pr1.g[b].push_back(Edge(a,0));
        }
        for(i=1; i<=n; i++)
            sort(Pr1.g[i].begin(),Pr1.g[i].end(),fff);
        Pr1.dfs(n-1);
        Pr1.output();
    }
    return 0;
}
/*
5 6
1 2
1 4
2 4
2 3
3 5
2 5

5 7
1 2
2 3
3 4
1 4
3 5
2 5
2 4

6 7
1 2
2 3
2 4
3 5
3 6
4 5
5 6

*/
