#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 55;
const int MAX_SUM = 55 * 100;
const int INF = 1e9 + 5;

bool isCalculated[MAX_N][MAX_SUM][100];
int n, height[MAX_N], ed, eu, dp[MAX_N][MAX_SUM][100];

int ComputeDp(int ind, int sum, int first) {
	if(ind == n + 1) {
		return 0;
	}
	else if(isCalculated[ind][sum][first]) {
		return dp[ind][sum][first];
	}

	int currSpeed = sum * ed - sum * eu + first * eu;

	dp[ind][sum][first] = INF;
	for(int i = 0; i <= 50; i++) {
		if(currSpeed >= i * eu) {
			dp[ind][sum][first] = min(dp[ind][sum][first], ComputeDp(ind + 1, sum + i, first) + abs(i - height[ind]));
		}
	}

	isCalculated[ind][sum][first] = true;
	return dp[ind][sum][first];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int remTests;
	cin >> remTests;

	while(remTests > 0) {
		remTests--;

		cin >> n;
		for(int i = 1; i <= n; i++) {
			cin >> height[i];
		}
		cin >> ed >> eu;
		
		if(eu >= 2 * ed) {
			long long sum = 0;
			for(int i = 2; i <= n; i++) {
				sum += 1ll * height[i];
			}
			
			cout << abs(height[1] - ((1ll * eu - 1ll * ed) * sum / 1ll * ed)) << endl;
		}
		else {
			memset(isCalculated, 0, sizeof(isCalculated));
			int ans = INF;
			for(int i = 0; i <= 50; i++) {
				ans = min(ans, ComputeDp(2, i, i) + abs(height[1] - i));
			}

			cout << ans << endl;
		}
	}

	return 0;
}
