#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 10);
const int bound = (int)1e4;

int n;
int h[MAXN];
int eu, ed;

void read()
{
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> h[i];
	cin >> ed >> eu;
}

int64_t dp[MAXN][MAXN * 50];
int64_t h0;

int64_t rec(int pos, int64_t t)
{
	if(pos == n) return 0;

	int64_t &memo = dp[pos][t];
	if(memo != -1) return memo;
	
	memo = (int64_t)1e17;
	
	int64_t total = h0 * 1ll * ed - t * 1ll * eu + t * 1ll * ed;
	for(int ch = h[pos]; ch >= 0; ch--)
		if(total >= ch * 1ll * eu)
			chkmin(memo, h[pos] - ch + rec(pos + 1, t + ch));
			
	return memo;		
}

int64_t solve(int64_t h0)
{
	::h0 = h0;
	for(int i = 0; i <= 2 * h0; i++)
		for(int p = 0; p <= n; p++)
			dp[p][i] = -1;
			
	return rec(1, 0);
}

void solve()
{
	int64_t sum = 0;
	for(int i = 0; i <= n; i++)
		sum += h[i];

	int64_t answer = sum;
	int64_t low = h[0], high = sum, mid;
	
	while(high - low >= 5)
	{
		mid = (low + high) >> 1ll;
		int64_t ans1 = mid - h[0] + solve(mid);
		int64_t ans2 = mid + 1 - h[0] + solve(mid + 1);
		
		chkmin(answer, ans1);
		chkmin(answer, ans2);
		
		if(ans1 < ans2)
			high = mid;
		else
			low = mid;
	}
	
	for(int h0 = low; h0 <= high; h0++)
		chkmin(answer, h0 - h[0] + solve(h0));

	cout << answer << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int T;
	cin >> T;
	
	while(T--)
	{	
		read();
		solve();
	}
	
	return 0;
}
