#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);

int n, m;
vector<pair<int, int> > poly;
vector<pair<int, int> > li;

void read()
{
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		poly.push_back({x, y});
	}
	
	cin >> m;
	
	if(m < 10000)
	{
		for(int i = 0; i < m; i++)
		{
			int x, y;
			cin >> x >> y;
			li.push_back({x, y});
		}
	}
	else
	{
		int a, b, c, d, p;
		cin >> a >> b >> c >> d >> p;
		li.push_back({a, b});
		for(int i = 1; i < m; i++)
		{
			int x = (li.back().first * 1ll * c + d) % p;
			int y = (li.back().second * 1ll * d + c) % p;
			li.push_back({x, y});
		}
	}
}

int corr[MAXN];

double dist[MAXN];

double sq(double x) { return x * x; }

double D(pair<int, int> a, pair<int, int> b)
{
	return sqrt(sq(a.first - b.first) + sq(a.second - b.second));
}

double ppp(int i, int j) 
{
	if(j >= i) return dist[j] - dist[i];  
	return dist[n - 1] - dist[i] + dist[j]; 
}

int64_t sum_x = 0, sum_y = 0;

inline int64_t eval(int64_t X, int64_t Y) { return -X * 1ll * sum_x - Y * 1ll * sum_y; }

void solve()
{
	for(int i = 0; i < n; i++)
		dist[i] = (i ? dist[i - 1] : 0) + D(poly[i], poly[(i - 1 + n) % n]);

	for(auto it: li)
		sum_x += it.first, sum_y += it.second;

	double Per = dist[n - 1];
	for(int i = 0; i < n; i++)
		if(dist[i] - dist[0] == Per / 2.0) 
			corr[0] = i; 

	for(int i = 1; i < n; i++)
	{
		corr[i]	= corr[i - 1];
		while(ppp(i, corr[i]) < Per / 2.0) 
			corr[i] = (corr[i] + 1) % n;
		
		if(ppp(i, corr[i]) != Per / 2.0)
			corr[i] = -1;
	}
	
	pair<double, double> ans1, ans2;
	int64_t ANS = (int64_t)1e18 + 17;
	
	for(int i = 0; i < n; i++)
		if(corr[i] != -1)
		{
			int64_t C1 = eval(poly[i].first, poly[i].second);
			int64_t C2 = eval(poly[corr[i]].first, poly[corr[i]].second);	
		
			if(C1 == C2)
			{
				ans1 = {poly[i].first, poly[i].second}; 
				ans2 = {poly[corr[i]].first, poly[corr[i]].second};
				break;			
			}
		}
	
	cout << setprecision(6) << fixed << ans1.first; cout << " ";
	cout << setprecision(6) << fixed << ans1.second; cout << endl;
	
	cout << setprecision(6) << fixed << ans2.first; cout << " ";
	cout << setprecision(6) << fixed << ans2.second; cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	read();
	solve();
	return 0;
}
