#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 1000007;
const double EPS = 0.00000001;
const double INF = 1e14;//.000000000000001;

struct point {
    double x,y;
    point(){}
    point(double a, double b): x(a), y(b) {}
};

int n,m;
point a[N];
double f[N];
double p[N];
double per;
int w1,w2;
double ans;
vector < pair < double, int > > v;

double square(double a) {
    return a*a;
}

double dist(point a, point b) {
    return sqrt(square(a.x-b.x) + square(a.y-b.y));
}

double get_distance(int x, int y) {
    if(x<y) return p[y]-p[x];
    return per-(p[x]-p[y]);
}

void read_points() {
    if(m<10000) {
        point curr;
        int i,j;

        for(i=0;i<m;i++) {
            cin>>curr.x>>curr.y;
            for(j=1;j<=n;j++) {
                f[j]+=dist(curr,a[j]);
            }
        }
    }
    else {
        int i,j,x,y,c,d,p;
        cin>>x>>y>>c>>d>>p;

        for(j=1;j<=n;j++) f[j]+=dist(point(x,y),a[j]);
        for(i=2;i<=m;i++) {
            x*=c;
            x+=d;
            x%=p;

            y*=d;
            y+=c;
            y%=p;
            
            for(j=1;j<=n;j++) f[j]+=dist(point(x,y),a[j]);
        }
    }
}

void go(vector < int > v) {
    if(v.size()<2) return;

    int i,j=0;
    double side1=0,side2=per;

    for(i=0;i<(int)(v.size());i++) {
        if(i>0) {
            double d=get_distance(v[i-1],v[i]);
            side1-=d;
            side2+=d;
        }
        while(side1<side2) {
            int z=j;
            if(++z>=(int)(v.size())) z=0;
            double d=get_distance(v[j],v[z]);
            side1+=d;
            side2-=d;
            j=z;
        }
        if(fabs(side1-side2)<ans) {
            ans=fabs(side1-side2);
            w1=v[i];
            w2=v[j];
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j,z;

    cin>>n;
    for(i=1;i<=n;i++) {
        cin>>a[i].x>>a[i].y;
    }

    for(i=2;i<=n;i++) {
        double d=dist(a[i-1],a[i]);
        p[i]=d;
        p[i]+=p[i-1];
        per+=d;
    }
    double d=dist(a[n],a[1]);
    per+=d;

    cin>>m;
    read_points();

    ans=INF;

    //for(i=1;i<=n;i++) cerr<<setprecision(1)<<fixed<<f[i]<<endl;

    /*for(i=1;i<=n;i++) {
        double s1=0;
        for(z=1;z<n;z++) {
            int j=i+z;
            if(j>n) j-=n;
            s1+=p[j];
            double s2=per-s1;
            if(fabs(f[i]-f[j])<EPS) {
                //cout<<fabs(s1-s2)<<endl;
                if(fabs(s1-s2)<ans) {
                    ans=fabs(s1-s2);
                    w1=i;
                    w2=j;
                }
            }
        }

    }*/

    for(i=1;i<=n;i++) {
        v.push_back(make_pair(f[i],i));
    }

    sort(v.begin(),v.end());

    for(i=0;i<(int)(v.size());i++) {
        vector < int > g;
        for(j=i;fabs(v[i].first-v[j].first)<=EPS;j++) {
            g.push_back(v[j].second);
        }
        go(g);
        i=j-1;
    }

    if(!(w1>0 && w2>0)) {
        cout<<setprecision(10)<<fixed<<a[1].x<<' '<<a[1].y<<endl<<a[1].x<<' '<<a[1].y<<endl;
        return 0;
    }

    assert(w1>0 && w2>0);

    cout<<setprecision(10)<<fixed<<a[w1].x<<' '<<a[w1].y<<endl<<a[w2].x<<' '<<a[w2].y<<endl;

    return 0;
}
