#include <bits/stdc++.h>
#define endl '\n'
#define time kahgjahkjajka

using namespace std;

const int N = 50007;

int n,m;
vector < int > v[N];
bool used[N];
int parent[N],low[N],time[N],current_time;
bool bridge_found;
vector < pair < int, int > > ans;

void dfs1(int node) {
    used[node]=true;
    low[node]=time[node]=++current_time;

    int i;

    for(i=0;i<(int)(v[node].size());i++) if(v[node][i]!=parent[node]) {
        if(used[v[node][i]]) {
            low[node]=min(low[node],low[v[node][i]]);
        }
        else {
            parent[v[node][i]]=node;
            dfs1(v[node][i]);
            low[node]=min(low[node],low[v[node][i]]);
        }
    }

    if(parent[node] && low[node]>time[parent[node]]) bridge_found=true;
}

void dfs2(int node, int from=-1) {
    used[node]=true;
    for(int i=0;i<(int)(v[node].size());i++) if(v[node][i]!=from) {
        if(used[v[node][i]]) {
            if(time[v[node][i]]<time[node]) ans.push_back(make_pair(node,v[node][i]));
        }
        else {
            ans.push_back(make_pair(node,v[node][i]));
            dfs2(v[node][i],node);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,x,y;

    scanf("%d %d", &n, &m);

    for(i=1;i<=m;i++) {
        scanf("%d %d", &x, &y);
        v[x].push_back(y);
        v[y].push_back(x);
    }

    dfs1(1);
    
    if(!bridge_found) {
        printf("1\n");
        memset(used,0,sizeof(used));
        dfs2(1);
        assert((int)(ans.size())==m);
        for(i=0;i<m;i++) {
            printf("%d %d\n", ans[i].first, ans[i].second);
        }
        return 0;
    }
    else {
        printf("0\n");
        return 0;
    }

    return 0;
}
