#include <bits/stdc++.h>
#define endl '\n'
#define time kahgjahkjajka

using namespace std;

const int N = 50007;

int n,m;
vector < int > v[N];
bool used[N];
int parent[N],low[N],time[N],current_time;
bool bridge_found;
vector < pair < int, int > > ans;
pair < int, int > which;
vector < pair < int, int > > edges;
int deg[N];

bool cmp(pair < int, int > a, pair < int, int > b) {
    return min(deg[a.first],deg[a.second])>min(deg[b.first],deg[b.second]);
}

void dfs1(int node) {
    used[node]=true;
    low[node]=time[node]=++current_time;

    int i;
    vector < pair < int, int > > g;
    vector < int > pref,suf;

    for(i=0;i<(int)(v[node].size());i++) if(v[node][i]!=parent[node]) {
        if(used[v[node][i]]) {
            low[node]=min(low[node],low[v[node][i]]);
        }
        else {
            parent[v[node][i]]=node;
            dfs1(v[node][i]);
            low[node]=min(low[node],low[v[node][i]]);
        }
    }

    if(parent[node] && low[node]>time[parent[node]]) bridge_found=true;
}

void dfs2(int node, int from=-1) {
    time[node]=++current_time;
    used[node]=true;
    for(int i=0;i<(int)(v[node].size());i++) if(v[node][i]!=from) {
        if(used[v[node][i]]) {
            if(time[v[node][i]]<time[node]) ans.push_back(make_pair(node,v[node][i]));
        }
        else {
            ans.push_back(make_pair(node,v[node][i]));
            dfs2(v[node][i],node);
        }
    }
}

void all_except(int idx) {
    int i;
    for(i=1;i<=n;i++) v[i].clear();
    for(i=0;i<m;i++) if(i!=idx) v[edges[i].first].push_back(edges[i].second),v[edges[i].second].push_back(edges[i].first);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,x,y;

    scanf("%d %d", &n, &m);
    which=make_pair(-1,-1);

    for(i=1;i<=m;i++) {
        scanf("%d %d", &x, &y);
        edges.push_back(make_pair(x,y));
        ++deg[x];
        ++deg[y];
    }

    //Try to find 2
    sort(edges.begin(),edges.end(),cmp);
    for(i=0;i<(int)(edges.size()) && clock()<=0.25*CLOCKS_PER_SEC;i++) {
        all_except(i);
        memset(used,0,sizeof(used));
        current_time=0;
        bridge_found=false;
        dfs1(1);
        if(!bridge_found) {
            printf("2\n");
            memset(used,0,sizeof(used));
            dfs2(1);
            assert((int)(ans.size())==m-1);
            for(i=0;i<m-1;i++) {
                printf("%d %d\n", ans[i].first, ans[i].second);
            }
            return 0;
        }
    }

    all_except(1000000);
    current_time=0;
    memset(used,0,sizeof(used));
    bridge_found=false;

    dfs1(1);
    
    if(!bridge_found) {
        printf("1\n");
        memset(used,0,sizeof(used));
        dfs2(1);
        assert((int)(ans.size())==m);
        for(i=0;i<m;i++) {
            printf("%d %d\n", ans[i].first, ans[i].second);
        }
        return 0;
    }
    else {
        printf("0\n");
        return 0;
    }

    return 0;
}
