# include <cstdio>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 5e4 + 10;
const int MAX_M = 1e5 + 10;

int n, m;
vector <int> v[MAX_N];

bool u[MAX_N];

vector <pair <int, int>> ans;

void dfs (int x, int par)
{
	u[x] = true;
	for (int i = 0; i < (int) v[x].size (); i ++)
	{
		if (v[x][i] == par)
			continue;	
		ans.push_back ({x, v[x][i]});
		if (!u[v[x][i]])
			dfs (v[x][i], x);
	}
}

int main ()
{
	int i, p, q;
	
	scanf ("%d%d", &n, &m);
	
	for (i = 0; i < m; i ++)
	{
		scanf ("%d%d", &p, &q);
		v[p].push_back (q);
		v[q].push_back (p);
	}
	
	for (i = 1; i <= n; i ++)
		if (v[i].size () <= 1)
		{
			printf ("0\n");
			return 0;
		}
		
	dfs (1, -1);

	printf ("2\n");
	for (i = 0; i < m; i ++)
		printf ("%d %d\n", ans[i].first, ans[i].second);
	
	return 0;
}

