# include <cstdio>
# include <vector>
# include <set>
# include <algorithm>

using namespace std;

const int MAX_N = 5e4 + 10;
const int MAX_M = 1e5 + 10;

int n, m;
vector <int> v[MAX_N];

bool u[MAX_N];

int nu[MAX_N];
vector <pair <int, int>> ans;

set <pair <int, int>> s;

void dfs (int x)
{
	
	for (; nu[x] < (int) v[x].size (); nu[x] ++)
	{
		if (s.find ({v[x][nu[x]], x}) == s.end ())
		{
			s.insert ({x, v[x][nu[x]]});
			nu[x] ++;
			dfs (v[x][nu[x] - 1]);
			break;
		}
		
	}
}

int main ()
{
	int i, p, q;
	
	scanf ("%d%d", &n, &m);
	
	for (i = 0; i < m; i ++)
	{
		scanf ("%d%d", &p, &q);
		v[p].push_back (q);
		v[q].push_back (p);
	}
	
	for (i = 1; i <= n; i ++)
	{
		random_shuffle (v[i].begin (), v[i].end ());
		if (v[i].size () <= 1)
		{
			printf ("0\n");
			return 0;
		}
	}
		
		
	bool fl = true;
	
	while (fl)
	{
		fl = false;
		for (i = n; i >= 1; i --)
			if (nu[i] < (int) v[i].size ())
			{
				dfs (i);
				fl = true;
			}
	}
			
	printf ("1\n");
	for (set <pair <int, int>> :: iterator it = s.begin (); it != s.end (); it ++)
		printf ("%d %d\n", (*it).first, (*it).second);
	
	return 0;
}

