#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<queue>
#include<vector>
#include<algorithm>
#include<cmath>
#include<cstring>
#include<stack>
#include<set>
#include<map>
using namespace std;
int n,m;
vector<int> v[50005];
int used[50005];
map<int,int> M[50005];
int cnt[50005];
int rev[50005];
vector<int> nv[50005];
int rq;
void read()
{
    cin>>n>>m;
    int i;
    int x,y;
    for(i=0;i<m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}
void dfs(int x)
{
    int i,j,sz,nb;
    rq=x;
    used[x]=1;
    sz=v[x].size();
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        if(!M[nb][x])
            {M[x][nb]=1; cnt[nb]++; nv[x].push_back(nb);}
        if(used[nb]) continue;
        dfs(nb);
    }
}
void rev_dfs(int x)
{
    int i,j,sz,nb;
    rev[x]=1;
    sz=v[x].size();
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        if(!M[x][nb]||rev[nb])
            continue;
        rev_dfs(nb);
    }
}
int check(int x, int s, int t)
{
    int i,nb,sz,ans=1;
    used[x]=1;
    sz=nv[x].size();
    for(i=0;i<sz;i++)
    {
        nb=nv[x][i];
        if(used[nb]||(x==s&&nb==t))
            continue;
        ans+=check(nb,s,t);
    }
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(false);
	read();
	dfs(1);
	rev_dfs(rq);
	int i;
	for(i=1;i<=n;i++)
    {
        if(!rev[i]||!cnt[i]||v[i].size()<2)
        {
            cout<<0<<"\n";
            return 0;
        }
    }
    int x,nb;
    int ch,sz,j;
    {
    for(i=n;i>=1;i--)
    {
        sz=nv[i].size();
        if(sz<2) continue;
        for(j=0;j<sz;j++)
        {
            memset(used,0,sizeof(used));
            ch=check(i,i,nv[i][j]);
            if(ch==n)
            {
                x=i;
                nb=nv[i][j];
                cout<<2<<"\n";
                cout<<i<<" "<<nv[i][j]<<"\n";
                for(i=1;i<=n;i++)
                {
                    sz=nv[i].size();
                    for(j=0;j<sz;j++)
                    {
                        if(i==x&&nv[i][j]==nb)
                            continue;
                        cout<<i<<" "<<nv[i][j]<<"\n";
                    }
                }
                return 0;
            }
        }
    }
    }
    cout<<1<<"\n";
    for(i=1;i<=n;i++)
    {
        sz=nv[i].size();
        for(j=0;j<sz;j++)
        {
            cout<<i<<" "<<nv[i][j]<<"\n";
        }
    }
	return 0;
}
/*
6 7
1 2
2 3
2 4
3 5
3 6
4 5
5 6

5 6
1 2
1 4
2 4
2 3
3 5
2 5

5 7
1 2
2 3
3 4
1 4
3 5
2 5
2 4
*/
