#include<iostream>
#include<vector>
#include<set>
using namespace std;
vector<int> susedi[50005];
int father[50005];
vector<pair<int,int>> streets;
bool noSol=false,addE=false;
set<int> notReached;
void dfs(int v){
	if(susedi[v].size()==1){
		noSol=true;
		return;
	}
	int goal=-1;
	for(int i=0;i<susedi[v].size();i++){
		if(susedi[v][i]==father[v]) continue;
		if(!father[susedi[v][i]]){
			notReached.insert(goal);
			goal=susedi[v][i];
		}else{
			if(notReached.find(susedi[v][i])==notReached.end()){
				addE=true;
			}
			notReached.erase(susedi[v][i]);
			streets.push_back({v,susedi[v][i]});
		}
	}
	if(goal==-1) return;
	streets.push_back({v,goal});
	father[goal]=v;
	dfs(goal);
	if(noSol) return;
	for(int i=0;i<susedi[v].size();i++){
		if(susedi[v][i]==father[v]) continue;
		if(!father[susedi[v][i]]){
			noSol=true;
			return;
		}
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,m,a,b;
	cin>>n>>m;
	for(int i=0;i<m;i++){
		cin>>a>>b;
		susedi[a].push_back(b);
		susedi[b].push_back(a);
	}
	notReached.insert(1);
	father[1]=-1;
	dfs(1);
	if(noSol){
		cout<<"0\n";
		return 0;
	}
	if(addE){
		cout<<"2\n";
	}else{
		cout<<"1\n";
	}
	for(int i=0;i<m;i++){
		cout<<streets[i].first<<" "<<streets[i].second<<"\n";
	}
	return 0;
}

