#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
using namespace std;

int n, m;
long double x[(1<<20)], y[(1<<20)], ptsx[(1<<20)], ptsy[(1<<20)];
long double cenX, cenY, lenAll = 0, len0[(1<<20)], th[(1<<20)];

inline long double dist2 ( long double x1, long double y1, long double x2, long double y2 ) {
    return ( x1-x2 )*(x1-x2) + (y1-y2)*(y1-y2);
}
inline long double dist ( long double x1, long double y1, long double x2, long double y2 ) {
    return sqrt( ( x1-x2 )*(x1-x2) + (y1-y2)*(y1-y2) );
}
struct p {
    long double x, y, len0;
    p () {}
    p ( long double x_, long double y_, long double len0_ ) {
        x = x_;
        y = y_;
        len0 = len0_;
    }
};
vector < p > v;

long double minD = (1LL<<42);
long double x1Ans, x2Ans, y1Ans, y2Ans;

long double getD ( long double rr ) {
    v.clear();

    long double ret = (1LL<<60);
    for ( int i = 0 ; i < n ; i ++ ) {
        double d1 = dist2( x[i], y[i], cenX, cenY );
        double d2 = dist2( x[(i+1)%n], y[(i+1)%n], cenX, cenY );

//        if ( d1 < rr-0.00001 && d2 < rr-0.00001 ) { continue; }
//        if ( d1-0.00001 > rr && d2-0.00001 > rr ) { continue; }

        long double l = 0, r = 1;

        long double ml = l + (r-l)/3, mr = l + 2*(r-l)/3;

        long double dx = x[( i+1 )%n] - x[i];
        long double dy = y[( i+1 )%n] - y[i];

        long double clx, cly;
        long double crx, cry;

        for ( int k = 0 ; k < 50 ; k ++ ) {
            clx = x[i] + dx*ml;
            cly = y[i] + dy*ml;

            crx = x[i] + dx*mr;
            cry = y[i] + dy*mr;

            if ( dist2( clx, cly, cenX, cenY ) > dist2( crx, cry, cenX, cenY ) ) {
                l = ml;
            }else {
                r = mr;
            }

            ml = l + (r-l)/3;
            mr = l + 2*(r-l)/3;

        }
        th[i] = l;


        clx = x[i] + dx*ml;
        cly = y[i] + dy*ml;


        l = 0;
        r = th[i];


        bool b = ( dist2( x[i], y[i] , cenX, cenY ) < dist2( clx, cly, cenX, cenY ) );

        long double t1, t2;

        long double mid = (l+r)/2;
        for ( int k = 0 ; k < 50 ; k ++ ) {

            clx = x[i] + dx*mid;
            cly = y[i] + dy*mid;

           //cout << l << " " << mid << " " << r << "\n";
           // cout << dist2( clx, cly, cenX, cenY ) << " " << rr << "\n";

            if ( ( ( dist2( clx, cly, cenX, cenY ) < rr ) )^b ) {
                r = mid;
            }else {
                l = mid;
            }

            mid = (l+r)/2;
        }

        t1 = mid;

        crx = x[i] + dx*ml;
        cry = y[i] + dy*ml;

//        cout << x[i] << " " << y[i] << " " << clx << " " << cly << "   " << x[(i+1)%n] << " " << y[(i+1)%n] << "\n";

        l = th[i];
        r = 1;

        b = ( dist2( x[i], y[i] , cenX, cenY ) > dist2( crx, cry, cenX, cenY ) );

        mid = (l+r)/2;
        for ( int k = 0 ; k < 50 ; k ++ ) {

            crx = x[i] + dx*mid;
            cry = y[i] + dy*mid;

           //cout << l << " " << mid << " " << r << "\n";
           // cout << dist2( clx, cly, cenX, cenY ) << " " << rr << "\n";

            if ( ( ( dist2( crx, cry, cenX, cenY ) > rr ) )^b ) {
                r = mid;
            }else {
                l = mid;
            }

            mid = (l+r)/2;
        }
        t2 = mid;

  //      cout << x[i] << " " << y[i] << " " << crx << " " << cry << "   " << x[(i+1)%n] << " " << y[(i+1)%n] << "\n";
  //      cout << dist2( clx, cly, cenX, cenY ) << '\n';
  //      cout << dist2( crx, cry, cenX, cenY ) << '\n';


        long double cLen = dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );

        if ( abs ( dist2( clx, cly, cenX, cenY ) - rr ) <= 0.0000001 ) {
            v.push_back( p( clx, cly, len0[i] + t1*cLen ) ); }


        if ( abs ( dist2( crx, cry, cenX, cenY ) - rr ) <= 0.0000001 ) { v.push_back( p( crx, cry, len0[i] + t2*cLen ) ); }


        clx = x[i] + dx*ml;
        cly = y[i] + dy*ml;


        l = 0;
        r = th[i];


        b = ( dist2( x[i], y[i] , cenX, cenY ) < dist2( clx, cly, cenX, cenY ) );

        t1, t2;

        mid = (l+r)/2;
        for ( int k = 0 ; k < 50 ; k ++ ) {

            clx = x[i] + dx*mid;
            cly = y[i] + dy*mid;

           //cout << l << " " << mid << " " << r << "\n";
           // cout << dist2( clx, cly, cenX, cenY ) << " " << rr << "\n";

            if ( ( ( dist2( clx, cly, cenX, cenY ) > rr ) )^b ) {
                r = mid;
            }else {
                l = mid;
            }

            mid = (l+r)/2;
        }

        t1 = mid;

        crx = x[i] + dx*ml;
        cry = y[i] + dy*ml;

//        cout << x[i] << " " << y[i] << " " << clx << " " << cly << "   " << x[(i+1)%n] << " " << y[(i+1)%n] << "\n";

        l = th[i];
        r = 1;

        b = ( dist2( x[i], y[i] , cenX, cenY ) > dist2( crx, cry, cenX, cenY ) );

        mid = (l+r)/2;
        for ( int k = 0 ; k < 50 ; k ++ ) {

            crx = x[i] + dx*mid;
            cry = y[i] + dy*mid;

           //cout << l << " " << mid << " " << r << "\n";
           // cout << dist2( clx, cly, cenX, cenY ) << " " << rr << "\n";

            if ( ( ( dist2( crx, cry, cenX, cenY ) < rr ) )^b ) {
                r = mid;
            }else {
                l = mid;
            }

            mid = (l+r)/2;
        }
        t2 = mid;

  //      cout << x[i] << " " << y[i] << " " << crx << " " << cry << "   " << x[(i+1)%n] << " " << y[(i+1)%n] << "\n";
  //      cout << dist2( clx, cly, cenX, cenY ) << '\n';
  //      cout << dist2( crx, cry, cenX, cenY ) << '\n';


        cLen = dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );

        if ( abs ( dist2( clx, cly, cenX, cenY ) - rr ) <= 0.0000001 ) {
            v.push_back( p( clx, cly, len0[i] + t1*cLen ) ); }


        if ( abs ( dist2( crx, cry, cenX, cenY ) - rr ) <= 0.0000001 ) { v.push_back( p( crx, cry, len0[i] + t2*cLen ) ); }


    }

  //  cout << v.size() << "\n";

    return 42;

    for ( int i = 0 ; i < v.size() ; i ++ ) {

//        cout << v[i].x << " " << v[i].y << "\n ";
        for ( int j = i+1 ; j < v.size() ; j ++ ) {

            //cout << i << " " << j << " : " << v[i].len0 << " " << v[j].len0 << "\n";

            long double cD = abs( v[i].len0 - v[j].len0 );
            if ( ret > abs( cD - ( lenAll - cD ) ) ) {
                ret = abs( cD - ( lenAll - cD ) );

                x1Ans = v[i].x;
                x2Ans = v[j].x;
                y1Ans = v[i].y;
                y2Ans = v[j].y;

            }
        }
    }
//    cout << "\n";
    return ret;
}

int main () {

    cout << setprecision( 6 ) << fixed;

    long double cl = (1LL<<60), far = 0;

    cin >> n;
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> x[i] >> y[i];
    }
    for ( int i = 0 ; i < n ; i ++ ) {
        len0[i] = lenAll;
        lenAll += dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );
    }

    cin >> m;
    for ( int i = 0 ; i < m ; i ++ ) {
        cin >> ptsx[i] >> ptsy[i];
        cenX += ptsx[i];
        cenY += ptsy[i];
    }
    cenX /= m;
    cenY /= m;

    for ( int i = 0 ; i < n ; i ++ ) {
        cl = min( cl, dist2( x[i], y[i], cenX, cenY ) );
        far = max( cl, dist2( x[i], y[i], cenX, cenY ) );
    }


    long double l = cl, r = far, ml = l + (r-l)/3 , mr = 2*(r-l)/3+l;

    for ( int k = 0 ; k < 150 ; k ++ ) {

        long double c1 = getD( ml ), c2 = getD ( mr );

//        cout << c1 << " " << c2 << " " << ml << " " << mr << "\n";

        if ( c1 > c2 ) {
            l = ml;
        }else {
            r = mr;
        }

        ml = l + (r-l)/3;
        mr = 2*(r-l)/3+l;
    }

  //  cout << getD( l ) << "\n";

    /*
    for ( int i = 0 ; i < n ; i ++ ) {
        long double cLen = dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );
        for ( int j = i+1 ; j != i ; j ++, j %= n ) {

            //if ( abs( sumD( x[i], y[i] ) - sumD( x[j], y[j] ) ) < 0.0000001 ) {

            if ( abs( dist2( x[i], y[i], cenX, cenY ) - dist2( x[j], y[j], cenX, cenY ) ) < 0.0000001 ) {
                if ( abs( cLen - ( lenAll-cLen) ) < minD ) {
                    minD =  abs( cLen - ( lenAll-cLen) );
                    x1Ans = x[i];
                    x2Ans = x[j];
                    y1Ans = y[i];
                    y2Ans = y[j];
                }
            }

            cLen += dist( x[j], y[j], x[(j+1)%n], y[(j+1)%n] );
        }
    }
    */
//    cout << minD << "\n";

    cout << x1Ans << " " << y1Ans << "\n";
    cout << x2Ans << " " << y2Ans << "\n";

    return 0;
}
