#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#define N 50001
using namespace std;
struct Edge
{
    int v,nas;
    Edge(int v,int nas):v(v),nas(nas){}
};
vector <Edge> g[N];
vector <Edge>::iterator it;
pair<int,int> out[2*N];
bool f[N];
int n,m,mechta=1,outbr=0,m1,m2;


bool fff(Edge a,Edge b)
{
    return a.v<b.v;
}

int fup[N],t[N],tim=0;

void addedge(int u,int v)
{
    out[outbr].first = u;
    out[outbr++].second = v;
    it=lower_bound(g[v].begin(),g[v].end(),Edge(u,0),fff);
    it->nas=1;
}

void dfs(int u)
{
    f[u]=1;
    t[u]=++tim;
    fup[u]=10000000;
  //  cout<<u<< endl;
    for(Edge e:g[u])
    {
        if(f[e.v]==0)
        {
            addedge(u,e.v);
            dfs(e.v);
            if(t[u]<fup[e.v]) mechta=0;
            fup[u]=min(fup[u],fup[e.v]);
        }
        else if(e.nas==0) fup[u]=min(fup[u],t[e.v]);
    }
    int maxt=0,maxv;
    for(Edge e:g[u])
    {
        if(e.nas==0 && t[e.v]<t[u])
            {
                if(mechta==1 && fup[u]<t[e.v])
                {
                    mechta=2;
                    m1=u; m2=e.v;
                    it=lower_bound(g[e.v].begin(),g[e.v].end(),Edge(u,0),fff);
                    it->nas=1;
                }
                else addedge(u,e.v);
            }
    }
    fup[u]=min(t[u],fup[u]);
    //cout<<u<<" - "<<fup[u]<< endl;

}

void output()
{
    cout<<mechta<< endl;
    if(mechta>0)
    {
        if(mechta==2)
                cout<<m1<<" "<<m2<< endl;
        for(int i=0; i<outbr; i++)
            printf("%i %i\n",out[i].first,out[i].second);
    }
}

int main()
{
    int a,b,i;
    cin>>n>>m;
    for(i=1; i<=m; i++)
    {
        scanf("%i%i",&a,&b);
        g[a].push_back(Edge(b,0));
        g[b].push_back(Edge(a,0));
    }
    for(i=1; i<=n; i++)
        sort(g[i].begin(),g[i].end(),fff);
    dfs(n/2);
    output();
    return 0;
}
/*
5 6
1 2
1 4
2 4
2 3
3 5
2 5

5 7
1 2
2 3
3 4
1 4
3 5
2 5
2 4

6 7
1 2
2 3
2 4
3 5
3 6
4 5
5 6

*/
