#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);
const int bound = (int)1e4;

int n;
int64_t h[MAXN];
int64_t eu, ed;

void read()
{
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> h[i];
	cin >> ed >> eu;
}

int64_t h0;

int64_t solve(int64_t h0)
{
	::h0 = h0;
	
	int64_t ret = h0 - h[0];
	int64_t total = h0 * 1ll * ed;
	for(int i = 1; i < n; i++)
	{
		int64_t ch = h[i];
		
		int64_t low = 0, high = ch, mid;
		while(low <= high)
		{
			mid = (low + high) >> 1ll;
			if(total >= mid * 1ll * eu)
				ch = mid, low = mid + 1;
			else 
				high = mid - 1;
		}
		
		ret += h[i] - ch;
		total -= eu * 1ll * ch;
		total += ed * 1ll * ch;
	}
	
	return ret;
}

void solve()
{
	int64_t sum = 0;
	for(int i = 0; i <= n; i++)
		sum += h[i];

	int64_t answer = sum;
	int64_t low = h[0], high = 2 * h[0], m1, m2;
	
	if(eu >= 2 * ed)
	{
		answer = solve(low);
		cout << answer << endl;
		return;
	}
	
	/*
	while(high - low >= 10)
	{
		m1 = low + (high - low) / 3; 
		m2 = high - (high - low) / 3;
		
		int64_t ans1 = solve(m1);
		int64_t ans2 = solve(m2);
		
		chkmin(answer, ans1);
		chkmin(answer, ans2);
		
		if(ans1 < ans2)
			high = m2;
		else
			low = m1;
	}*/
	
	for(int h0 = low; h0 <= high; h0++)
		chkmin(answer, solve(h0));

	cout << answer << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int T;
	cin >> T;
	
	while(T--)
	{	
		read();
		solve();
	}
	
	return 0;
}
