#include<iostream>
#include<stdio.h>
#include<cmath>
using namespace std ;

#define eps 0.000001
#define MAXN 10000007

int n , m ;
struct tuhla {
    double x , y ;
};

tuhla a[ 2 * MAXN ] ;
tuhla b[ 2 * MAXN ] ;

pair < long long , long long > autism ;

double dist[ 2 * MAXN ] ;
double tot ;

double f[ 2 * MAXN ] ;


double get ( int id ) {
    int i ;
    double ret = 0.00000000 ;
    for ( i = 1 ; i <= m ; i ++ ) {
        double cur = ( a[ id ].x - b[ i ].x ) * ( a[ id ].x - b[ i ].x ) + ( a[ id ].y - b[ i ].y ) * ( a[ id ].y - b[ i ].y ) ;
        cur = sqrt ( cur ) ;
        ret = ret + cur ;
    }
    return ret ;
}

void input ( ) {
    //scanf ( "%d" , &n ) ;
    cin >> n ;
    int i ;
    for ( i = 1 ; i <= n ; i ++ ) {
        //scanf ( "%lf%lf" , &a[ i ].x , &a[ i ].y ) ;
        cin >> a[ i ].x >> a[ i ].y ;
        a[ n + i ] = a[ i ] ;
    }
    //scanf ( "%d" , &m ) ;
    cin >> m ;
    if ( m < 10000 ) {
        for ( i = 1 ; i <= m ; i ++ ) {
            //scanf ( "%lf%lf" , &b[ i ].x , &b[ i ].y ) ;
            cin >> b[ i ].x >> b[ i ].y ;
        }
    }
    else {
        cin >> autism.first >> autism.second ;
        b[ 1 ].x = autism.first ;
        b[ 1 ].y = autism.second ;
        long long c , d , p ;
        cin >> c >> d >> p ;
        for ( i = 2 ; i <= m ; i ++ ) {
            long long u1 , u2 ;
            u1 = ( ( ( 1LL * autism.first ) * c + d ) % p ) ;
            u2 = ( ( ( 1LL * autism.second ) * d + c ) % p ) ;
            autism = make_pair ( u1 , u2 ) ;
            b[ i ].x = autism.first ;
            b[ i ].y = autism.second ;
        }
    }
    for ( i = 2 ; i <= n + 1 ; i ++ ) {
        double aux = ( a[ i ].x - a[ i - 1 ].x ) * ( a[ i ].x - a[ i - 1 ].x ) + ( a[ i ].y - a[ i - 1 ].y ) * ( a[ i ].y - a[ i - 1 ].y ) ;
        dist[ i ] = sqrt ( aux ) ;
        tot += dist[ i ] ;
        if ( i <= n ) { dist[ i + n ] = dist[ i ] ; }
    }
}

void solve ( ) {
    int l , r ;
    r = 1 ;
    double h = tot ;
    int ans1 , ans2 ;
    int i , j ;
    ans1 = ans2 = 1 ;
    for ( i = 1 ; i <= 2 * n ; i ++ ) {
        f[ i ] = get ( i ) ;
    }
    for ( i = 1 ; i <= n ; i ++ ) {
        double cur = 0.00000 ;
        for ( j = i + 1 ; j < i + n ; j ++ ) {
            cur += dist[ j ] ;
            if ( f[ j ] - f[ i ] > -eps && f[ j ] - f[ i ] < eps ) {
                double w = max ( cur , tot - cur ) ;
                if ( h < 0 ) {
                    h = w ;
                    ans1 = i ;
                    ans2 = j ;
                }
                if ( h > w ) {
                    h = w ;
                    ans1 = i ;
                    ans2 = j ;
                }
            }
        }
    }
    printf ( "%.6lf %.6lf\n" , 1.000000000 * a[ ans1 ].x , 1.000000000 * a[ ans1 ].y ) ;
    printf ( "%.6lf %.6lf\n" , 1.000000000 * a[ ans2 ].x , 1.000000000 * a[ ans2 ].y ) ;
}

int main ( ) {
    input ( ) ;
    solve ( ) ;
    return 0 ;
}
/**
4
0 0
0 2
2 2
2 0
1
1 4
**/
