#include<iostream>
#include<stdio.h>
#include<cmath>
using namespace std ;

#define eps 0.0001
#define MAXN 10000007

int n , m ;
struct tuhla {
    long long x , y ;
};

tuhla a[ 2 * MAXN ] ;
tuhla b[ 2 * MAXN ] ;

double dist[ 2 * MAXN ] ;
double tot ;

double f[ 2 * MAXN ] ;


double get ( int id ) {
    int i ;
    double ret = 0.00000000 ;
    for ( i = 1 ; i <= m ; i ++ ) {
        double cur = ( a[ id ].x - b[ i ].x ) * ( a[ id ].x - b[ i ].x ) + ( a[ id ].y - b[ i ].y ) * ( a[ id ].y - b[ i ].y ) ;
        cur = sqrt ( cur ) ;
        ret = ret + cur ;
    }
    return ret ;
}

void input ( ) {
    scanf ( "%d" , &n ) ;
    int i ;
    for ( i = 1 ; i <= n ; i ++ ) {
        scanf ( "%lld%lld" , &a[ i ].x , &a[ i ].y ) ;
        a[ n + i ] = a[ i ] ;
    }
    scanf ( "%d" , &m ) ;
    if ( m < 10000 ) {
        for ( i = 1 ; i <= m ; i ++ ) {
            scanf ( "%lld%lld" , &b[ i ].x , &b[ i ].y ) ;
        }
    }
    else {
        scanf ( "%lld%lld" , &b[ 1 ].x , &b[ 1 ].y ) ;
        long long c , d , p ;
        scanf ( "%lld%lld%lld" , &c , &d , &p ) ;
        for ( i = 2 ; i <= m ; i ++ ) {
            b[ i ].x = ( b[ i - 1 ].x * c + d ) % p ;
            b[ i ].y = ( b[ i - 1 ].y * d + c ) % p ;
        }
    }
    for ( i = 2 ; i <= n + 1 ; i ++ ) {
        long long aux = ( a[ i ].x - a[ i - 1 ].x ) * ( a[ i ].x - a[ i - 1 ].x ) + ( a[ i ].y - a[ i - 1 ].y ) * ( a[ i ].y - a[ i - 1 ].y ) ;
        dist[ i ] = sqrt ( aux ) ;
        tot += dist[ i ] ;
        if ( i <= n ) { dist[ i + n ] = dist[ i ] ; }
    }
}

void solve ( ) {
    int l , r ;
    r = 1 ;
    double cur = 0.0000000 ;
    double h = -1 ;
    int ans1 , ans2 ;
    int i , j ;
    ans1 = ans2 = -1 ;
    for ( i = 1 ; i <= 2 * n ; i ++ ) {
        f[ i ] = get ( i ) ;
    }
    for ( i = 1 ; i <= n ; i ++ ) {
        double cur = 0.00000 ;
        for ( j = i + 1 ; j < i + n ; j ++ ) {
            cur += dist[ j ] ;
            if ( f[ j ] - f[ i ] > -eps && f[ j ] - f[ i ] < eps ) {
                double w = min ( cur , tot - cur ) ;
                if ( h < 0 ) {
                    h = w ;
                    ans1 = i ;
                    ans2 = j ;
                }
                if ( h > w ) {
                    h = w ;
                    ans1 = i ;
                    ans2 = j ;
                }
            }
        }
    }
    printf ( "%.6lf %.6lf\n" , 1.000000 * a[ ans1 ].x , 1.000000 * a[ ans1 ].y ) ;
    printf ( "%.6lf %.6lf\n" , 1.000000 * a[ ans2 ].x , 1.000000 * a[ ans2 ].y ) ;
}

int main ( ) {
    input ( ) ;
    solve ( ) ;
    return 0 ;
}
/**
4
0 0
0 2
2 2
2 0
1
1 4
**/
