# include <cstdio>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int n;
int h[MAX_N];
long long ed, eu;
long long ans;

inline long long try_with (long long euc)
{
	int i;
	long long crr, edc, p;
	p = edc = 0;
	p = -euc;
	crr = 0;
	
	for (i = 2; i <= n; i ++)
	{
		crr += (h[i - 1] - p) * ed;
		
		if (h[i] * eu <= crr)
		{
			crr -= h[i] * eu;
			p = 0;
		}
		else
		{
			p = (h[i] * eu - crr) / eu;
			if ((h[i] * eu - crr) % eu)
				p ++;
			if (p > h[i])
				break;
			///printf ("%d %d\n", i, p);
			edc += p;
			crr -= (h[i] - p) * eu;	
		}
	}
		
	if (i <= n)
		return (1LL << 60);
		
	///printf ("-- %lld\n", edc);
	
	if (edc + euc < ans)
		ans = edc + euc;
		
	return edc + euc;
}


void solve ()
{
	int i, j, fl = 0;
	long long sum = 0, f, euc, l, r, mid, sm;
	scanf ("%d", &n);
	for (i = 1; i <= n; i ++)
	{
		scanf ("%d", &h[i]);
		sum += h[i];
	}
	
	sum -= h[1];
	
	scanf ("%lld%lld", &ed, &eu);
	
	ans = sum;
	
	if (2 * ed <= eu)
	{
		ans = try_with (0);
		printf ("%lld\n", ans);
		return;
	}
	
	l = -1;
	r = (1LL << 41);
	
	while (r - l > 1)
	{
		mid = (l + r) >> 1;
		
		long long crr = try_with (mid), p, q;
		
		///printf ("%lld %lld %lld %lld %lld\n", l, r, mid, crr, ans);
		
		sm = crr;
		fl = 0;
				
		for (i = 1; i <= 16; i ++)
		{
			p = q = -1;
			if (mid - i > l)
				p = try_with (mid - i);
			if (mid + i < r)
				q = try_with (mid + i);
			if (p != -1 && sm > p)
			{
				sm = p;
				fl = -i;
			}
			if (q != -1 && sm >= q)
			{
				sm = q;
				fl = i;
			}
		}
		
		if (fl >= 0)
			l = mid + fl;
		else
			r = mid + fl;
	} 
	
	
	printf ("%lld\n", ans);
}

int main ()
{
	int t;
	scanf ("%d", &t);
	while (t --)
		solve ();
	return 0;
}

