#include <iostream>
#include <cmath>
#include <iomanip>
using namespace std;

int n, m;
long double x[(1<<20)], y[(1<<20)], ptsx[(1<<20)], ptsy[(1<<20)];
long double cenX, cenY, lenAll = 0;

long double dist2 ( long double x1, long double y1, long double x2, long double y2 ) {
    return ( x1-x2 )*(x1-x2) + (y1-y2)*(y1-y2);
}
long double dist ( long double x1, long double y1, long double x2, long double y2 ) {
    return sqrt( ( x1-x2 )*(x1-x2) + (y1-y2)*(y1-y2) );
}

long double minD = (1LL<<42);
long double x1Ans, x2Ans, y1Ans, y2Ans;

int main () {

    cout << setprecision( 6 ) << fixed;

    cin >> n;
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> x[i] >> y[i];
    }
    for ( int i = 0 ; i < n ; i ++ ) {
        lenAll += dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );
    }

    cin >> m;
    for ( int i = 0 ; i < m ; i ++ ) {
        cin >> ptsx[i] >> ptsy[i];
        cenX += ptsx[i];
        cenY += ptsy[i];
    }
    cenX /= m;
    cenY /= m;


    for ( int i = 0 ; i < n ; i ++ ) {
        long double cLen = dist( x[i], y[i], x[(i+1)%n], y[(i+1)%n] );
        for ( int j = i+1 ; j != i ; j ++, j %= n ) {

            if ( dist2( x[i], y[i], cenX, cenY ) == dist2( x[j], y[j], cenX, cenY ) ) {
                if ( min( cLen, lenAll-cLen) < minD ) {
                    minD =  min( cLen, lenAll-cLen);
                    x1Ans = x[i];
                    x2Ans = x[j];
                    y1Ans = y[i];
                    y2Ans = y[j];
                }
            }

            cLen += dist( x[j], y[j], x[(j+1)%n], y[(j+1)%n] );
        }
    }


    cout << x1Ans << " " << y1Ans << "\n";
    cout << x2Ans << " " << y2Ans << "\n";

    return 0;
}
