#include<iostream>
using namespace std;

const int MAX_N=100100;
int eu,ed;
long long h[MAX_N];
long long ans;
int n;

void input()
{
    cin>>n;
    for (int i=0;i<n;++i)
    {
        cin>>h[i];
    }
    cin>>ed>>eu;
}
void output()
{
    cout<<ans<<'\n';
}
long long checkh0(long long h0)
{
    long long dh=h0-h[0];
    if (dh<0) dh=-dh;
    long long e=h0*ed;
    long long th;
    for (int i=1;i<n;++i)
    {
        //cerr<<i<<" "<<e<<" "<<h[i]*eu<<endl;
        if (e>=h[i]*eu)
        {
            e-=h[i]*eu;
            e+=h[i]*ed;
        }
        else
        {
            th=e/eu;
            e-=th*eu;
            e+=th*ed;
            dh+=(h[i]-th);
        }
    }
    return dh;
}
double checkh0d(long long h0)
{
    double dh=h0-h[0];
    if (dh<0) dh=-dh;
    double e=h0*ed;
    double th;
    for (int i=1;i<n;++i)
    {
        //cerr<<i<<" "<<e<<" "<<h[i]*eu<<endl;
        if (e>=h[i]*eu)
        {
            e-=h[i]*eu;
            e+=h[i]*ed;
        }
        else
        {
            th=e*1.0/eu;
            e-=th*eu;
            e+=th*ed;
            dh+=(h[i]-th);
        }
    }
    return dh;
}
void solve1()
{
    long long left=h[0];
    long long right=1e13;
    long long m1,m2;
    double l1,l2,r2,r1;
    l1=checkh0d(left);
    r1=checkh0d(right);
    while (right-left>5)
    {
        m1=(left*2+right)/3;
        m2=(left+right*2)/3;
        l2=checkh0d(m1);
        r2=checkh0d(m2);
        if (l2<r2)
        {
            right=m2;
            r1=r2;
        }
        else
        {
            left=m1;
            l1=l2;
        }
    }
    left=(left+right)/2;
    ans=checkh0(left);
    for (long long i=left+1;i-left<5;++i)
    {
        ans=min(ans,checkh0(i));
    }
    for (long long i=left-1;left-i<5 && i>=h[0];--i)
    {
        ans=min(ans,checkh0(i));
    }
}
void solve()
{
    if (eu>=2*ed)
    {
        ans=checkh0(h[0]);
    }
    else solve1();
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin>>t;
    for (int i=0;i<t;++i)
    {
        //reset();
        input();
        solve();
        output();
    }

    return 0;
}
