#include<iostream>
#include<vector>
using namespace std;

const int MAX_N=50100;
const int MAX_M=100100;
struct Edge
{
    int f,t;
    bool use;
};
vector<int> ne[MAX_N];
Edge all[MAX_M],walk;
int sol;
int n,m;

void input()
{
    cin>>n>>m;
    int a,b;
    for (int i=0; i<m; ++i)
    {
        cin>>a>>b;
        --a;
        --b;
        ne[a].push_back(b);
        ne[b].push_back(a);
    }
}
void output()
{
    cout<<sol<<'\n';
    if (sol!=0)
    {
        if (sol==2)
            cout<<walk.f+1<<' '<<walk.t+1<<'\n';
        for (int i=0; i<m; ++i)
        {
            if (all[i].use==0)
                continue;
            cout<<all[i].f+1<<' '<<all[i].t+1<<'\n';
        }
    }
}
int et[MAX_N],mt[MAX_N];
int ct;
int ce;
void DFS(int p, int a)
{
    //cerr<<p+1<<" , "<<a+1<<endl;
    et[a]=ct;
    mt[a]=ct;
    ++ct;
    int curr;
    int lre=-1; //last reverse edge
    int cce;
    for (int i=0; i<ne[a].size(); ++i)
    {
        curr=ne[a][i];
        if (curr==p || et[curr]==-1)
            continue;
        //cerr<<"  "<<a+1<<" "<<curr+1<<"  "<<mt[a]<<" "<<mt[curr]<<endl;
        all[ce].f=a;
        all[ce].t=curr;
        all[ce].use=1;
        cce=ce;
        ++ce;
        if (sol==1)
        {
            if (mt[a]<=mt[curr])
            {
                sol=2;
                all[cce].use=0;
                walk.f=a;
                walk.t=curr;
                lre=cce;
            }
            else
            {
                if (lre!=-1)
                {
                    sol=2;
                    all[lre].use=0;
                    walk.f=all[lre].f;
                    walk.t=all[lre].t;
                }
                lre=cce;

            }
        }
        mt[a]=min(mt[a],mt[curr]); //up edge
    }
    for (int i=0; i<ne[a].size(); ++i)
    {
        curr=ne[a][i];
        if (curr==p || et[curr]!=-1)
            continue;
        //cerr<<"  "<<a+1<<" "<<curr+1<<"  "<<mt[a]<<" "<<mt[curr]<<endl;
        all[ce].f=a;
        all[ce].t=curr;
        all[ce].use=1;
        cce=ce;
        ++ce;
        DFS(a,curr);
        if (sol==1 && mt[curr]<=mt[a] && lre!=-1)
        {
            sol=2;
            all[lre].use=0;
            walk.f=all[lre].f;
            walk.t=all[lre].t;
        }
        mt[a]=min(mt[a],mt[curr]); //down edge
    }
    if (a!=0 && et[a]==mt[a])
    {
        sol=0;
    }
}
void solve()
{
    sol=1;
    for (int i=0; i<n; ++i)
    {
        et[i]=-1;
        mt[i]=-1;
    }
    ct=0;
    ce=0;
    DFS(-1, 0);
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
